#include <pwd.h>
#include "fmt.h"
#include "stralloc.h"

extern getpw_mysql();
stralloc message = { 0 };
char strnum[FMT_ULONG];

int main(int argc, char **argv) {
  struct passwd *pw;

  if (argc < 3) {
    puts("usage: _authen username password");
    return die();
  }
  strnum[fmt_ulong(strnum, getppid())] = 0;
  pw = getpw_mysql(argv[1], argv[2]);
  if ((int) pw < 3) return die();
  printf("%s:*:%d:%d:%s:%s\n", pw->pw_name, pw->pw_uid, pw->pw_gid,
                               pw->pw_dir, pw->pw_shell);
  return 0;
}

int die() {
  if (message.len) puts(message.s);
  return 111;
}
